"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.delegatify = void 0;
function delegatify(originalMethod, keyResolver) {
    const delegatedKeysMap = new Map();
    const keyGenerator = keyResolver !== null && keyResolver !== void 0 ? keyResolver : JSON.stringify;
    return function (...args) {
        const key = keyGenerator(...args);
        if (!delegatedKeysMap.has(key)) {
            delegatedKeysMap.set(key, originalMethod.apply(this, args).finally(() => delegatedKeysMap.delete(key)));
        }
        return delegatedKeysMap.get(key);
    };
}
exports.delegatify = delegatify;
//# sourceMappingURL=delegatify.js.map