"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.multiDispatch = void 0;
const multi_dispatchify_1 = require("./multi-dispatchify");
function multiDispatch(dispatchesAmount) {
    return (target, propertyName, descriptor) => {
        if (descriptor.value) {
            descriptor.value = (0, multi_dispatchify_1.multiDispatchify)(descriptor.value, dispatchesAmount);
            return descriptor;
        }
        throw new Error('@multiDispatch is applicable only on a methods.');
    };
}
exports.multiDispatch = multiDispatch;
//# sourceMappingURL=multi-dispatch.js.map