"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.throttle = void 0;
const throttlify_1 = require("./throttlify");
function throttle(delayMs) {
    return (target, propertyName, descriptor) => {
        if (descriptor.value) {
            descriptor.value = (0, throttlify_1.throttlify)(descriptor.value, delayMs);
            return descriptor;
        }
        throw new Error('@throttle is applicable only on a methods.');
    };
}
exports.throttle = throttle;
//# sourceMappingURL=throttle.js.map