"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const throttle_1 = require("./throttle");
const test_utils_1 = require("../common/test-utils");
describe('throttle', () => {
    it('should make sure error thrown when decorator not set on method', () => {
        try {
            const nonValidThrottle = (0, throttle_1.throttle)(50);
            class T {
            }
            __decorate([
                nonValidThrottle,
                __metadata("design:type", String)
            ], T.prototype, "boo", void 0);
        }
        catch (e) {
            expect('@throttle is applicable only on a methods.').toBe(e.message);
            return;
        }
        throw new Error('should not reach this line');
    });
    it('should verify method invocation is throttled', () => __awaiter(void 0, void 0, void 0, function* () {
        class T {
            foo(x) {
                return this.goo(x);
            }
            goo(x) {
                expect(this.prop).toBe(3);
            }
        }
        __decorate([
            (0, throttle_1.throttle)(20),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Number]),
            __metadata("design:returntype", void 0)
        ], T.prototype, "foo", null);
        const t = new T();
        t.prop = 3;
        const spy = jest.spyOn(T.prototype, 'goo');
        t.foo(1);
        expect(spy).toBeCalledTimes(1);
        expect(spy).toBeCalledWith(1);
        yield (0, test_utils_1.sleep)(10);
        t.foo(2);
        expect(spy).toBeCalledTimes(1);
        expect(spy).lastCalledWith(1);
        yield (0, test_utils_1.sleep)(30);
        t.foo(3);
        expect(spy).toBeCalledTimes(2);
        expect(spy).lastCalledWith(3);
    }));
});
//# sourceMappingURL=throttle.spec.js.map