"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const timeout_1 = require("./timeout");
const utils_1 = require("../common/utils/utils");
const timeout_index_1 = require("./timeout.index");
describe('timeout', () => {
    it('should make sure error thrown when decorator not set on method', () => {
        try {
            const nonValidTimeout = (0, timeout_1.timeout)(50);
            class T {
            }
            __decorate([
                nonValidTimeout,
                __metadata("design:type", String)
            ], T.prototype, "boo", void 0);
        }
        catch (e) {
            expect('@timeout is applicable only on a methods.').toBe(e.message);
            return;
        }
        throw new Error('should not reach this line');
    });
    it('should throw timeout exception after provided ms', () => __awaiter(void 0, void 0, void 0, function* () {
        const ms = 50;
        class T {
            foo() {
                return __awaiter(this, void 0, void 0, function* () {
                    yield (0, utils_1.sleep)(100);
                });
            }
        }
        __decorate([
            (0, timeout_1.timeout)(ms),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", Promise)
        ], T.prototype, "foo", null);
        const t = new T();
        try {
            yield t.foo();
            throw new Error('should not reach here');
        }
        catch (e) {
            expect(e.message).toEqual(`timeout occurred after ${ms}`);
            expect(e instanceof timeout_index_1.TimeoutError).toBeTruthy();
        }
    }));
    it('should no throw timeout exception after provided ms', () => __awaiter(void 0, void 0, void 0, function* () {
        const ms = 100;
        class T {
            foo() {
                return __awaiter(this, void 0, void 0, function* () {
                    yield (0, utils_1.sleep)(50);
                    return Promise.resolve(1);
                });
            }
        }
        __decorate([
            (0, timeout_1.timeout)(ms),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", Promise)
        ], T.prototype, "foo", null);
        const t = new T();
        expect(yield t.foo()).toEqual(1);
    }));
});
//# sourceMappingURL=timeout.spec.js.map