import { CanceledPromise } from './canceled-promise';
export function cancelPreviousify(originalMethod) {
    let rej;
    return function (...args) {
        if (rej) {
            rej(new CanceledPromise());
        }
        return new Promise((resolve, reject) => {
            rej = reject;
            originalMethod.apply(this, args)
                .then((data) => resolve(data))
                .catch((err) => reject(err));
        });
    };
}
//# sourceMappingURL=cancel-previousify.js.map