export function multiDispatchify(originalMethod, dispatchesAmount) {
    return function (...args) {
        return new Promise((resolve, reject) => {
            let rejectionsAmount = 0;
            const catchHandler = (e) => {
                rejectionsAmount += 1;
                if (rejectionsAmount === dispatchesAmount) {
                    reject(e);
                }
            };
            for (let i = 1; i <= dispatchesAmount; i += 1) {
                originalMethod.apply(this, ...args)
                    .then(resolve)
                    .catch(catchHandler);
            }
        });
    };
}
//# sourceMappingURL=multi-dispatchify.js.map