export function throttlify(originalMethod, delayMs) {
    let throttling = false;
    return function (...args) {
        if (!throttling) {
            throttling = true;
            originalMethod.apply(this, args);
            setTimeout(() => {
                throttling = false;
            }, delayMs);
        }
    };
}
//# sourceMappingURL=throttlify.js.map