import { TimeoutError } from './timeout-error';
export function timeoutify(originalMethod, ms) {
    return function (...args) {
        return new Promise((resolve, reject) => {
            originalMethod.apply(this, args).then((data) => {
                resolve(data);
            });
            setTimeout(() => {
                reject(new TimeoutError(ms));
            }, ms);
        });
    };
}
//# sourceMappingURL=timeoutify.js.map